<%@ page import="com.ether.WebHelper" %>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags" %>

<script type="text/javascript">

var InterfaceStatistics = Class.create( {
    initialize: function()
    {
        /** *********** CONTAINERS *********** **/
        this.parent = $( "#containerMiddle" );
        this.containerMenu = $( "#menuLogo" );
        this.containerErrors = $( "#errors" );

        /** *********** VARIABLES *********** **/
        this.language = '<spring:message code="language"/>';
        this.webmaster = "<%=WebHelper.getProperty(request, "mail.webmaster")%>";
        this.jSONUser = <%=WebHelper.getJSONUser( request )%> ? <%=WebHelper.getJSONUser( request )%> : false;
        this.logoSizeSmall = 30;
        this.logoSizeBig = 50;

        this.projectsArray = [
            {id:"ETHER", img:"logo_Ether_50.jpg", top:"-16px", left:"125px"},
            {id:"NDACC", img:"logo_Ndacc_50.jpg", top:"1.66667px", left:"46.3334px"},
            {id:"ECCAD", img:"logo_ECCAD_50.gif", top:"39.3333px", left:"109.333px"},
            {id:"IASI", img:"logo_iasi_50.jpg", top:"-78.6667px", left:"77.6666px"},
            {id:"GOSAT", img:"logo_gosat_50.jpg", top:"-0.333328px", left:"200.667px"},
            {id:"IAGOS", img:"logo_Iagos_50.jpg", top:"36px", left:"138px"},
            {id:"TROPICO", img:"logo_tropico_50.jpg", top:"-74px", left:"45px"},
            {id:"MEGAPOLI", img:"logo_Megapoli_50.png", top:"-74.3333px", left:"15.3333px"},
            {id:"MIMOSA", img:"logo_mimosa_50.png", top:"-45.6667px", left:"76.3334px"},
            {id:"REPROBUS", img:"logo_reprobus_50.png", top:"-48px", left:"161.667px"},
            {id:"GEISA", img:"logo_geisa_50.jpg", top:"22px", left:"167.667px"},
            {id:"TAPAS", img:"logo_tapas_50.png", top:"58.3333px", left:"125px"},
            {id:"OUTREACH", img:"logo_acomida_50.jpg", top:"-77.3333px", left:"225px"},
            {id:"OMER7A", img:"logo_omer7A_50.jpg", top:"22.6667px", left:"76.3334px"},
            {id:"GIRAFE", img:"logo_girafe_50.JPG", top:"-79.6667px", left:"192.333px"},
            {id:"ARLETTY", img:"logo_arletty_50.jpg", top:"-79px", left:"161.667px"}
        ];
        this.widthInitMentionsOrCredits = $( "#mentions" ).width();

        this.xArray = ["2010-10", "2010-11", "2010-12", "2011-01", "2011-02"];
        this.yArray = [0, 10, 30, 50, 100];

        this.bindButtons();
        this.createMenuLogo();

        $( document ).ready( jQuery.proxy( function()
        {
            $( ".containerToDrag" ).draggable();
            // Menu
            this.animateMenuLogos();
            this.bindMenuLogos();
            this.createRightSlide();

            if( !this.jSONUser )
                this.onClickHelp();
            else
                this.handleLogin();
        }, this ) );
    },


    // CREATES AND BINDS ********************************************************
    bindButtons: function()
    {
        $( "#home_button" ).bind( "dblclick", this.onClickHome );
        $( "#language_button" ).bind( "dblclick", jQuery.proxy( this.onClickLanguage, this ) );
        $( "#mail_button" ).bind( "dblclick", jQuery.proxy( this.onClickMail, this ) );
        $( "#help" ).bind( "click", jQuery.proxy( this.onClickHelp, this ) );
        $( "#credits" ).bind( "dblclick", jQuery.proxy( this.onClickCredits, this ) );
        $( "#mentions" ).bind( "dblclick", jQuery.proxy( this.onClickMentions, this ) );
        $( "#login_button" ).bind( "click", jQuery.proxy( this.onClickLogin, this ) );
        $( "#logout_button" ).bind( "dblclick", jQuery.proxy( this.onClickLogout, this ) );
    },

    createMenuLogo: function()
    {
        var initTop = this.projectsArray[0].top;
        var initLeft = this.projectsArray[0].left;

        jQuery.each( this.projectsArray, jQuery.proxy( function( i, logo )
        {
            var divLogo = $( document.createElement( "div" ) );
            divLogo.addClass( "divLogo containerToDrag" );
            divLogo.attr( {id:logo.id, style:"position:absolute; top:" + initTop + "; left:" + initLeft} );
            divLogo.html( '<img id="img_' + logo.id + '"src="resources/images/' + logo.img + '" width="' + this.logoSizeSmall + 'px" height="' + this.logoSizeSmall + 'px"/>' );
            this.containerMenu.append( divLogo );
        }, this ) );
    },

    createAllSlides: function()
    {
        this.middleSlide = new DragSlide( {id:"middle", parent:this.parent, width:"700", height:"480", top:"150px", left:"38px",
            specificClass:"containerStatistics", specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent"} );

        this.rightSlide = new DragSlide( {id:"right", parent:this.parent, width:"180", height:"320", top:"175px", left:"750px",
            specificClass:"containerStatistics", specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent"} );

        this.loginSlide = new DragSlide( {id:"loginMiddle", parent:this.parent, width:"150", height:"25", top:"115px", left:"39px",
            specificClass:"containerStatistics", specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent", activeDbClick:"None"} );
    },

    createRightSlide: function()
    {
//        this.rightSlide = new DragSlide( {id:"right", parent:this.parent, width:"200", height:"270", top:"210px", left:"698px",
//            specificClass:"containerStatistics", specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent"} );
        this.rightSlide = new DragSlide( {id:"right", parent:this.parent, width:"180", height:"320", top:"175px", left:"750px",
            specificClass:"containerStatistics", specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent"} );
    },

    // REQUESTS ********************************************************
    requestChangeLocale: function()
    {
        $.ajax( {
            url: "project?methodName=setLocale&language=<spring:message code="label.language.value.to.switch"/>",
            success:function()
            {
                location.reload();
            },
            error: jQuery.proxy( this.showErrors, [this] )
        } );
    },

    requestLogin: function()
    {
        var login = $( "#loginValue" ).val();
        var pwd = $( "#pwdValue" ).val();
        $.ajax( {
            url: "project?methodName=login&login=" + login + "&pwd=" + pwd,
            dataType: 'json', // Info needed since jquery.1.7 !!
            success:jQuery.proxy( this.handleLogin, this ),
            error: jQuery.proxy( this.showErrors, [this, "489px", "566px"] )
        } );
    },

    requestLogout: function()
    {
        $.ajax( {
            url: "project?methodName=logout",
            dataType: 'json', // Info needed since jquery.1.7 !!
            success:jQuery.proxy( this.handleLogout, this ),
            error: jQuery.proxy( this.showErrors, [this] )
        } );
    },

    requestDataByLogo: function()
    {
        if( !this.selectedLogo && !this.selectedLogo.id )
            return;

        $.ajax( {
            url: "statistic?methodName=searchMainStatisticsByProject&name=" + this.selectedLogo.id,
            success:jQuery.proxy( this.handleDataByLogo, this ),
            error: jQuery.proxy( this.showLoginError, this )
        } );
    },

    // HANDLES ********************************************************
    handleDataByLogo: function( result )
    {
        this.displaySummary();
    },

    handleLogin: function( result )
    {
        this.containerErrors.empty();
        this.containerErrors.css( "visibility", "hidden" );

        if( result )
            this.jSONUser = result.jSONUser;

        $( "#loginValue" ).val( "" );
        $( "#pwdValue" ).val( "" );
        $( "#login_text" ).css( "visibility", "hidden" );
        $( "#login" ).animate( {
            top:'47px',
            left:'577px'
        }, 2000, function()
        {
        } );

        $( "#login_bg" ).animate( {
            opacity: 1,
            height:'60px',
            width:'67px'
        }, 2000, function()
        {
        } );

        $( "#login_img" ).animate( {
            top:'25px',
            left: '16px',
            width: '0',
            height: '0'
        }, 2000, jQuery.proxy( function()
        {
            // Slides
            this.parent.empty();
            this.createAllSlides();
            this.changeRightSlide();

            // User
            if( this.jSONUser.name )
                this.loginSlide.setTitle( this.jSONUser.name );
            else
                this.loginSlide.setTitle( '<spring:message code="label.unknown"/>' );
            $( "#logout_button" ).css( "visibility", "visible" );

            // Awstats button
            if( "ADMINISTRATOR" == this.jSONUser.role )
            {
                this.awstatsSlide = new DragSlide( {id:"awstats", parent:this.parent, width:"120", height:"25", top:"114px", left:"197px",
                    specificTitleClass:"containerStatisticsTitle", specificContentClass:"containerStatisticsContent",
                    title:'<spring:message code="label.awstats"/>&nbsp;&nbsp;', activeDbClick:"None"} );
                this.awstatsSlide.getDivContainer().dblclick( jQuery.proxy( this.displayAwstatsStatistics, this ) );
            }

            // Logo
            this.selectedLogo = $( "#ETHER" )[0];
            this.isSelectedLogoEther = true;
            this.onClickLogo();
        }, this ) );
    },

    handleLogout: function()
    {
        this.jSONUser = false;
        this.parent.empty();
        this.createRightSlide();
        this.onClickHelp();

        $( "#logout_button" ).css( "visibility", "hidden" );
        $( "#login" ).css( { zIndex:1 } ).animate( {
            top:'79px',
            left:'88px'
        }, 2000, function()
        {
        } );

        $( "#login_bg" ).animate( {
            opacity: 0.85,
            height:'500px',
            width:'500px'
        }, 2000, function()
        {
            $( "#login_text" ).css( "visibility", "visible" );
        } );

        $( "#login_img" ).animate( {
            top:'103px',
            left: '148px',
            width: '30px',
            height: '30px'
        }, 2000, function()
        {
        } );
    },

    // EVENTS ********************************************************
    onClickHome: function()
    {
        location.reload();
    },

    onClickLanguage: function()
    {
        this.requestChangeLocale();
    },

    onClickMail: function()
    {
        document.location.href = "mailto:" + this.webmaster + "?subject=[STATISTICS]";
    },

    onClickMentions: function()
    {
        if( this.widthInitMentionsOrCredits == $( "#mentions" ).width() )
            this.enlargeCreditsOrMentions( $( "#mentions" ), $( "#mentions_bg" ), $( "#mentions_text" ), $( "#mentions_title" ), "project/mentions_" + this.language + ".jsp" );
        else
            this.reduceCreditsOrMentions( $( "#mentions" ), $( "#mentions_bg" ), $( "#mentions_text" ), $( "#mentions_title" ), "project/mentions_" + this.language + ".jsp" );
    },

    onClickCredits: function()
    {
        if( this.widthInitMentionsOrCredits == $( "#credits" ).width() )
            this.enlargeCreditsOrMentions( $( "#credits" ), $( "#credits_bg" ), $( "#credits_text" ), $( "#credits_title" ), "project/credits_" + this.language + ".jsp" );
        else
            this.reduceCreditsOrMentions( $( "#credits" ), $( "#credits_bg" ), $( "#credits_text" ), $( "#credits_title" ), "project/credits_" + this.language + ".jsp" );
    },

    onClickHelp: function()
    {
        this.rightSlide.setTitle( '<spring:message code="label.help"/>' );
        this.rightSlide.setContent( "<spring:message code='label.help.content'/>" );
        if( this.jSONUser )
            var backHelpButton = new Button( {value:"<spring:message code="label.display.actions"/>", parent:this.rightSlide.getDivContent(), className: "small positive back_button", onClick:jQuery.proxy( this.changeRightSlide, this )} );
    },

    onClickLogin: function()
    {
        this.containerErrors.empty();
        this.containerErrors.css( "visibility", "hidden" );
        this.requestLogin();
    },

    onClickLogout: function()
    {
        this.requestLogout();
    },

    onClickLogo: function()
    {
        this.isSelectedLogoEther = (this.selectedLogo == $( "#ETHER" )[0]);

        if( this.jSONUser )
            this.requestDataByLogo();
        else
        {
            this.showErrors( "<spring:message code="error.connection.need"/>" );
            this.containerErrors.css( {top:"489px", left:"566px"} );
            this.containerErrors.css( "visibility", "visible" );
        }
    },

    onClickPrint: function()
    {
        var printContent = new PrintContent();
        printContent.addContent( $( "#title" ).clone() );
        printContent.addContent( this.middleSlide.getDivContainer().clone().animate( {'marginLeft' : "+=120px"} ) );
        printContent.displayPrintPreview();
    },

    // OTHERS ********************************************************
    showErrors: function( result )
    {
        var context = this[0] ? this[0] : this;
        var topValue = this[1] ? this[1] : false;
        var leftValue = this[2] ? this[2] : false;
        context.containerErrors.show();
        if( result.responseText && interfaceTexts[result.responseText] )
            context.containerErrors.html( interfaceTexts[result.responseText] );
        else if( result.responseText )
            context.containerErrors.html( result.responseText );
        else
            context.containerErrors.html( result );
        if( topValue && leftValue )
            context.containerErrors.css( {top: topValue, left: leftValue} );
        context.containerErrors.css( "visibility", "visible" );
    },

    showLoginError: function( result )
    {
        this.onClickLogout();
        this.onClickLogo();
    },

    reduceCreditsOrMentions: function( div, div_bg, div_text, div_title )
    {
        div.css( { zIndex:0 } );
        div_text.css( "visibility", "hidden" );
        div.animate( {
            left: '+=500',
            top: '+=500'
        }, 2000, function()
        {
        } );
        div_bg.animate( {
            opacity: 1,
            height:'42px',
            width:this.widthInitMentionsOrCredits + 'px',
            zIndex:'0'
        }, 2000, function()
        {
            div_title.css( "visibility", "visible" );
        } );
    },

    enlargeCreditsOrMentions: function( div, div_bg, div_text, div_title, pageToLoad )
    {
        div_title.css( "visibility", "hidden" );
        div.css( { zIndex:1 } );
        div.animate( {
            left: '-=500',
            top: '-=500'
        }, 2000, function()
        {
        } );

        div_bg.animate( {
            opacity: 0.95,
            height:'500px',
            width:'500px'
        }, 2000, function()
        {
            div_text.css( "visibility", "visible" );
            div_text.load( pageToLoad );
        } );
    },

    animateMenuLogos: function()
    {
        jQuery.each( this.projectsArray, jQuery.proxy( function( i, logo )
        {
            $( "#" + logo.id ).animate( {
                top:logo.top,
                left:logo.left
            }, 5000, function()
            {
            } );
        }, this ) );
    },

    bindMenuLogos: function()
    {
        var gap = (this.logoSizeBig - this.logoSizeSmall) / 2;
        var logoSizeBig = this.logoSizeBig + "px";
        var logoSizeSmall = this.logoSizeSmall + "px";
        var gridimage;

        $( '.divLogo' ).mouseover( function( element )
        {
            gridimage = $( this ).find( 'img' ); //Define target as a variable
            gridimage.stop().animate( {
                width: logoSizeBig,
                height: logoSizeBig
            }, 150 );
            $( this ).animate( {
                top: "-=10px",
                left: "-=10px"
            }, 150 );
        } );

        $( '.divLogo' ).mouseout( function( element )
        {
            $( this ).animate( {
                top: "+=10px",
                left: "+=10px"
            }, 150 );
            gridimage.stop().animate( {
                width: logoSizeSmall,
                height:logoSizeSmall
            }, 150 );
        } );

        $( '.divLogo' ).dblclick( jQuery.proxy( function( element )
        {
            this.selectedLogo = element.currentTarget;
            this.onClickLogo();
        }, this ) );
    },

    changeRightSlide: function()
    {
        this.rightSlide.setTitle( '<spring:message code="label.actions"/>' );
        this.rightSlide.getDivContent().empty();
        new Button( {value:"<spring:message code="statistics.summary"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displaySummary, this )} );
        new Button( {value:"<spring:message code="statistics.monthly"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayMonthly, this )} );
        new Button( {value:"<spring:message code="statistics.daily"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayDaily, this )} );
        new Button( {value:"<spring:message code="statistics.daysofweek"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayDaysOfWeek, this )} );
        new Button( {value:"<spring:message code="statistics.hours"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayHours, this )} );
        new Button( {value:"<spring:message code="statistics.visit.duration"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayVisitDuration, this )} );

        new Button( {value:"<spring:message code="statistics.visit"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayVisit, this )} );
        new Button( {value:"<spring:message code="statistics.domain"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayDomainCountry, this )} );
        new Button( {value:"<spring:message code="statistics.data.download"/>", parent:this.rightSlide.getDivContent(), className: "positive action_button", onClick:jQuery.proxy( this.displayDownload, this )} );

        new Button( {value:"<spring:message code="label.print"/>", parent:this.rightSlide.getDivContent(), className: "blue export_button print-preview", onClick:jQuery.proxy( this.onClickPrint, this )} );
    },

    changeMiddleSlide: function( title, url )
    {
        this.middleSlide.setTitle( this.selectedLogo.id + ' : ' + title );
        this.middleSlide.getDivContent().empty();

        this.middleSlide.getDivContent().load( url + this.selectedLogo.id );
    },


    // STATISTICS ********************************************************
    displaySummary: function()
    {
        this.changeMiddleSlide( '<spring:message code="statistics.summary"/>', <%=WebHelper.getProperty(request, "url.summary")%> );
    },

    displayMonthly: function()
    {
        this.changeMiddleSlide( '<spring:message code="statistics.monthly"/>', <%=WebHelper.getProperty(request, "url.monthly")%> );
    },

    displayDaily: function()
    {
        this.changeMiddleSlide( '<spring:message code="statistics.daily"/>', <%=WebHelper.getProperty(request, "url.daily")%> );
    },

    displayDaysOfWeek: function()
    {
        this.changeMiddleSlide( '<spring:message code="statistics.daysofweek"/>', <%=WebHelper.getProperty(request, "url.daysofweek")%> );
    },

    displayHours: function()
    {
        this.changeMiddleSlide( '<spring:message code="statistics.hours"/>', <%=WebHelper.getProperty(request, "url.hours")%> );
    },

    displayVisitDuration: function()
    {
        this.changeMiddleSlide( '<spring:message code="statistics.visit.duration"/>', <%=WebHelper.getProperty(request, "url.sessions")%> );
    },

    displayVisit: function()
    {
        this.changeMiddleSlide( '<spring:message code="statistics.visit"/>', <%=WebHelper.getProperty(request, "url.visited.pages")%> );
    },

    displayDomainCountry: function()
    {
        this.changeMiddleSlide( '<spring:message code="statistics.domain"/>', <%=WebHelper.getProperty(request, "url.domains")%> );
    },

    displayDownload: function()
    {
        this.changeMiddleSlide( '<spring:message code="statistics.data.download"/>', <%=WebHelper.getProperty(request, "url.downloads")%> );
    },

    displayAwstatsStatistics: function()
    {
        window.open( "http://www.pole-ether.fr/cgi-bin/awstats/awstats.pl?config=" + this.selectedLogo.id );
    }

} );

</script>
